;************** ASM file header stuff ***************

	@library        tinxlib
;	include macros.h

;******************* Constants ***********************

FIELD_WIDTH	EQU	48	;bytes, must be multiple of 4
FIELD_HEIGHT	EQU	200	;pixels

;************ Generate Landscape *************
;* Generates a random landscape on the field *
;* Algorithm by: Andreas Ess                 *
;* In: a0=pointer to field memory            *
;*********************************************
 label generate_landscape

	movem.l		a5-a6/d0-d3,-(a7)

	moveq		#7,d3			;Start bit for x
	move.l		#FIELD_HEIGHT/4,d1
	jsr		flib[random]		;Start y-coordinate (added by algorithm)
	add.l		#FIELD_HEIGHT*2/3,d1
	mulu.w		#FIELD_WIDTH,d1		;Offset for start y

	moveq		#FIELD_WIDTH-1,d2	;Column counter

\loop	tst.l		d1
	blt.s		\cont
	cmp.l		#FIELD_WIDTH*FIELD_HEIGHT,d1
	bge.s		\cont
	bset.w		d3,0(a5,d1)		;Plot pixel at current position
\cont	moveq		#5,d0
	jsr		flib[random]
	tst.b		d0
	beq.s		\up
	cmp.b		#1,d0
	beq.s		\rup
	cmp.b		#2,d0
	beq.s		\right
	cmp.b		#3,d0
	beq.s		\rdwn

\down	add.l		#FIELD_WIDTH,d1		;Move down one pixelrow
	bra.s		\loop

\up	sub.l		#FIELD_WIDTH,d1		;Move up one pixelrow
	bra.s		\loop

\rup	sub.l		#FIELD_WIDTH,d1		;Move up one pixelrow
	bra.s		\right

\rdwn	add.l		#FIELD_WIDTH,d1		;Move down one pixelrow

\right	dbra		d3,\loop	;Move one bit to the right

	addq.l		#1,d1		;Move one word to the right
	moveq		#7,d3		;Reset bit counter

	dbra		d2,\loop	;Next column

;* Now we've got to fill in the dirt :) *
	move.l		#(FIELD_WIDTH/4)-1,d2		;Column counter

\oloop	move.l		a5,a6				;Start adress
	move.l		#FIELD_HEIGHT-1,d0		;Pixelrow counter
\tloop	move.l		(a6),d1
	tst.l		d1
	beq.s		\iloop
	dbra		d0,\tloop
	bra.s		\cont2

\iloop	move.l		(a6),d3
	or.l		d3,d1
	move.l		d1,(a6)
	add.l		#FIELD_WIDTH,a6
	dbra		d0,\iloop

\cont2	addq.l		#4,a5
	dbra		d2,\oloop

	movem.l		(a7)+,a5-a6/d0-d3
	rts

;************** End of Fargo program ****************

	reloc_open
	add_library	flib
	reloc_close
	end
